module Encoding.QuotedPrintable
  ( encqp
  , decqp
  ) where

import Data.ByteString as B
import qualified Data.ByteString.Char8 as BC
import qualified Codec.Binary.QuotedPrintable as QP
import Data.ByteString.UTF8 as BSU      -- from utf8-string
-- import qualified Data.ByteString.Char8 as C

import qualified Data.Text as T
import qualified Data.Text.Encoding as T
-- import qualified Data.Text.IO as T

-- decqp :: String -> String
-- decqp input =
--    case QP.decode (BSU.fromString input) of
--      Right decoded -> T.unpack (T.decodeUtf8 decoded)
--      Left _ -> "Error decoding QP.\n"
decqp :: B.ByteString -> B.ByteString
decqp input =  case QP.decode input of
                 Right byteString -> byteString
                 Left _ -> BC.pack "Error: Invalid Quoted Printable input"

-- encqp :: String -> String
-- encqp = C.unpack . QP.encode . BSU.fromString
encqp :: B.ByteString -> B.ByteString
encqp = QP.encode
